/*===========================================================================
/
/                                   ttPage
/                           ʃwb_t@C
/
/============================================================================
/ Copyright (C) 1998-2018 Sota. All rights reserved.
/
/ Redistribution and use in source and binary forms, with or without
/ modification, are permitted provided that the following conditions
/ are met:
/
/  1. Redistributions of source code must retain the above copyright
/     notice, this list of conditions and the following disclaimer.
/  2. Redistributions in binary form must reproduce the above copyright
/     notice, this list of conditions and the following disclaimer in the
/     documentation and/or other materials provided with the distribution.
/
/ THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
/ IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
/ OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
/ IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
/ INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
/ BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
/ USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
/ ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
/ (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
/ THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
/============================================================================*/


#include "helpid.h"

#ifdef ENGLISH
#include "mesg_eng.h"
#else
#include "mesg_jpn.h"
#endif


#define PROGRAM_VERSION_NUM     995     /* o[W */


#define LOW8(x)                 ((x) & 0xFF)
#define HIGH8(x)                (((x) >> 8) & 0xFF)

#define NUL                     _T('\0')

#define FAIL                    0
#define SUCCESS                 1

#define NO                      0
#define YES                     1

#define MY_MAX_PATH             MAX_PATH

#if 0
#define WM_MOUSEWHEEL95         (WM_USER+1)
#endif
#define WM_LBUTTONTRICLK        (WM_USER+2)
#define WM_US_EDIT_CLOSE        (WM_USER+3)
#define WM_CHANGE_TOP           (WM_USER+4)


#define REGISTORY_VER           91      /* ݂̐ݒf[^̃o[W */
#define REGISTORY_VER_TOOL      91      /* c[ݒ肪ύXɂȂf[^̃o[W */
#define REGISTORY_VER_KEY       91      /* L[ݒ肪ύXɂȂf[^̃o[W */
#define REGISTORY_VER_EXT       90      /* gqݒ肪ύXɂȂf[^̃o[W */

#define TIMER_EDITWAIT          1       /* GfB^I҂^C}[ID */

#define LEFT_OFFSET             8       /* \̍ɂsNZ */

#define TOOLWIN_HEIGHT          28      /* c[o[̍ */

#define EDITOR_OPT_LEN          20      /* c[̃IvV̍ő咷 */

#define HISTORY_MAX             20      /* t@C̃qXg̍ő */
#define DEF_FMENU_ITEMS         4       /* Filej[ɂ鍀ڐ̏l */

#define ONELINE_MAXLEN          260     /* Ps̐܂Ԃ̍ől */

#define LINETBLMAX              1000    /* P̍s擪ʒuf[^e[uɃZbgłs */

#define ATTRDATAMAX             50      /* P̃Agr[gf[^e[uɃZbgłf[^̐ */

#define FINDSTR_LEN             80      /* ̒ */
#define FINDHIST_NUM            10      /* ̃qXǧ */

#define FOUNDDATAMAX            50      /* P̌ʃf[^e[uɃZbgłf[^ */

#define QUOTE_MAXLEN            20      /* p̍ő咷 */

/* Agr[g */
#define ATTR_REGION             0x80000000  /* ͈͎w */
#define ATTR_UNDER              0x40000000  /* A_[C */
#define ATTR_BOLD               0x20000000  /*  */

/* t@C^Cvʐݒ */
#define EXT_NUM_STEP            10      /* t@C^Cvʐݒ̃obt@gTCY */
#define EXT_NAME_LEN            40      /* t@C^Cvʐݒ薼̍ő咷 */
#define EXT_EXT_LEN             500     /* t@C^Cvʐݒ̃t@C̑S̒ */

/* R}hCł̃XCb` */
#define OPT_SJIS                0x0001  /* VtgJISw肳ꂽ */
#define OPT_JIS                 0x0002  /* JISw肳ꂽ */
#define OPT_EUC                 0x0004  /* EUCw肳ꂽ */
#define OPT_UTF16               0x0008  /* UTF16w肳ꂽ */
#define OPT_UTF16BE             0x0010  /* UTF16(BE)w肳ꂽ */
#define OPT_UTF8                0x0020  /* UTF8w肳ꂽ */
#define OPT_UTF7                0x0040  /* UTF7w肳ꂽ */

/* ̎ */
#define CHAR_SPACE              -1      /*  */
#define CHAR_CTRL               -2      /* Rg[R[h */
#define CHAR_HAN_ALPHA          -3      /* pp */
#define CHAR_HAN_KANA           -4      /* p */
#define CHAR_ZEN_HIRA           -5      /* SpЂ炪 */
#define CHAR_ZEN_KATA           -6      /* SpJ^Ji */
#define CHAR_ZEN_CHOU           -7      /* Sp */
#define CHAR_ZEN_ALPHA          -8      /* Spp */
#define CHAR_OTHER              -9      /* ̑ */

/* GR[h̎ */
#define ENCODE_UTF8_CHECK       -5      /* UTF8 (BOM̃`FbNKv) */
#define ENCODE_UTF16_BE_CHECK   -4      /* UTF16 (Big Endian) (BOM̃`FbNKv) */
#define ENCODE_UTF16_CHECK      -3      /* UTF16 (BOM̃`FbNKv) */
#define ENCODE_UNKNOWN          -2      /* s */
#define ENCODE_AUTO             -1      /* F */
#define ENCODE_SJIS             0       /* SHIFT-JIS */
#define ENCODE_JIS              1       /* JIS */
#define ENCODE_EUC              2       /* EUC */
#define ENCODE_UTF16_BOM        3       /* UTF16 with BOM */
#define ENCODE_UTF16_BOM_BE     4       /* UTF16 with BOM (Big Endian) */
#define ENCODE_UTF16_NOBOM      5       /* UTF16 without BOM */
#define ENCODE_UTF16_NOBOM_BE   6       /* UTF16 without BOM (Big Endian) */
#define ENCODE_UTF8_BOM         7       /* UTF8 with BOM */
#define ENCODE_UTF8_NOBOM       8       /* UTF8 without BOM */
#define ENCODE_UTF7_NOBOM       9       /* UTF7 */

/* ǂݍ݌ */
#define READFROM_NONE           -1      /* ǂݍłȂ */
#define READFROM_FILE           0       /* t@Cǂݍ */
#define READFROM_CBOARD         1       /* Nbv{[hǂݍ */
#define READFROM_STDIN          2       /* W͂ǂݍ */

/* UI_xxx ͏ԂςȂ */
#define UI_WINDOWS              0       /* Windows@ */
#define UI_LESS                 1       /* Less@ */
#define UI_DOS                  2       /* DOS@ */

/* sR[h̎ */
#define TERM_UNKNOWN            -1      /* s */
#define TERM_CRLF               0       /* CR-LF */
#define TERM_LF                 1       /* LF */
#define TERM_CR                 2       /* CR */

/*  */
#define DIST_FORWARD            0       /* O */
#define DIST_BACKWARD           1       /*  */

/* WXg̃^Cv */
#define REGTYPE_REG             0       /* WXg */
#define REGTYPE_INI             1       /* INIt@C */

#define REG_SECT_MAX            (16*1024)   /* WXĝPZNV̍őf[^TCY */

/* sԍ̃^Cv */
#define LINENUM_WP              0       /* ܂Ԃ܂łPsƐ */
#define LINENUM_EDITOR          1       /* sR[h܂łPs𐔂 */

/* c[̃^Cv */
#define TOOL_TYPE_ASSOC         0       /* ֘Atꂽc[ */
#define TOOL_TYPE_SPECIFIED     1       /* w肳ꂽc[ */

/* Xe[^Xԍ */
#define STATUS_WIN_ENCODE           0   /* GR[h̕\ʒu */
#define STATUS_WIN_TERMINATION_CODE 1   /* sR[h̕\ʒu */
#define STATUS_WIN_TOP_LINE_NUM     2   /* y[W擪s̕\ʒu */
#define STATUS_WIN_MOUSE_LINE_NUM   3   /* }EXJ[\s̕\ʒu */
#define STATUS_WIN_FILE_INFO        4   /* t@C̕\ʒu */


/*===== Agr[g =====*/
typedef struct {
    LPTSTR AttrPos;                 /* C̊Jnʒu */
    int AttrLen;                    /* C̒ */
    int AttrData;                   /* Cf[^ */
} TEXTATTR;


/*===== Agr[gf[^e[u =====*/
typedef struct attrtbl {
    int AttrNum;                    /* C̐ */
    TEXTATTR Attr[ATTRDATAMAX];     /* f[^ */
    struct attrtbl *Next;           /* linked list */
} ATTRTBL;


/*===== s擪ʒuf[^ =====*/
typedef struct linetoptbl {
    int Lines;                      /* s */
    LPTSTR LineTop[LINETBLMAX];     /* 擪ʒuf[^(LINETBLMAXs) */
    int LineNum[LINETBLMAX];        /* _sԍis܂łPsƂĐj */
    struct linetoptbl *Next;        /* linked list */
} LINETOPTBL;


/*===== f[^ =====*/
typedef struct {
    _TCHAR Str[FINDSTR_LEN+1];      /*  */
    int CapsFlg;                    /* 啶/ʂ邩ǂ (YES/NO) */
    int Regexp;                     /* K\ (YES/NO) */
} FINDDLGDATA;


/*===== ʃf[^ =====*/
typedef struct founddata {
    LPTSTR Pos;                     /* ʒu */
    int Len;                        /*  */
} FOUNDDATA;


/*===== ʃf[^e[u =====*/
typedef struct foundtbl {
    int StrNum;                     /*  */
    FOUNDDATA Find[FOUNDDATAMAX];   /* ʒu */
    struct foundtbl *Next;          /* linked list */
} FOUNDTBL;


/*===== t@CǗf[^ =====*/
typedef struct filemantbl {
    _TCHAR              Fname[MAX_PATH+1];      /* t@C */
    int                 ReadFrom;               /* t@Cǂݍݐ (READFROM_xxx) */
    int                 Encoding;               /* GR[fBO (ENCODE_xxx) */
    int                 TermCode;               /* sR[h (TERM_xxx) */
    BYTE                *TextDataAreaTop;       /* eLXgf[^̈̐擪 */
    LPTSTR              TextData;               /* eLXgf[^ */
    int                 TextSize;               /* eLXgf[^̃TCY */
    int                 TextLines;              /* \C */
    LINETOPTBL          *LineData;              /* s擪ʒuf[^ */
    ATTRTBL             *AttrData;              /* Agr[gf[^ */
    int                 DispTopLine;            /* ݂̕\擪s */
    int                 DispTopColumn;          /* ݂̕\擪 */
    int                 SbarStep;               /* XN[o[̈ړXebv (1`) */
    int                 FindStrLen;             /* ̒ (0=ĂȂ) */
    _TCHAR              FindStr[FINDSTR_LEN+1]; /*  */
    FOUNDTBL            *FoundTbl;              /* ʃe[u */
    int                 RgnSelecting;           /* ͈͎w蒆tO (YES/NO) */
    LPTSTR              RgnStartPos;            /* ͈͎wJnAhX */
    LPTSTR              RgnEndPos;              /* ͈͎w薖AhX */
    struct filemantbl   *Next;                  /* linked list */
} FILEMANTBL;


/*===== t@C^Cvʐݒ =====*/
typedef struct extset {
    _TCHAR      Name[EXT_NAME_LEN+1];       /* O */
    _TCHAR      Exts[EXT_EXT_LEN+1];        /* t@Ci}`XgOj */
    int         TabWidth;                   /* ^u */
    int         FoldPos;                    /* ܂Ԃʒu */
    int         LineSpace;                  /* s */
    int         CrMark;                     /* s\ (YES/NO) */
    int         TabMark;                    /* ^u\ (YES/NO) */
    int         HanSpcMark;                 /* ps\ (YES/NO) */
    int         ZenSpcMark;                 /* Sps\ (YES/NO) */
    int         LineNumDisp;                /* sԍ̕\ (YES/NO) */
    int         LineNumType;                /* sԍ̕\@ (LINENUM_xxx) */
    int         FoldRight;                  /* E[Ő܂Ԃ (YES/NO) */
    LOGFONT     Font;                       /* tHg */
    COLORREF    TextColor;                  /* F */
    COLORREF    HighColor;                  /* F */
    COLORREF    BackColor;                  /* wiF */
    COLORREF    FindColor;                  /* ̔wiF */
    COLORREF    CtrlColor;                  /* 䕶F */
    COLORREF    CrColor;                    /* sF */
    COLORREF    TabColor;                   /* ^uF */
    COLORREF    HanSpcColor;                /* psF */
    COLORREF    ZenSpcColor;                /* SpsF */
    int         ToolType;                   /* c[̃^Cv (TOOL_TYPE_xxx) */
    int         EditAndClose;               /* c[Jƕ */
    int         EditAutoReLoad;             /* c[Iēǂݍ */
    _TCHAR      EditorName[MAX_PATH+1];     /* c[̃pX */
    _TCHAR      EditOptEUC[EDITOR_OPT_LEN+1];       /* EUC̎̃IvV */
    _TCHAR      EditOptJIS[EDITOR_OPT_LEN+1];       /* JIS̎̃IvV */
    _TCHAR      EditOptSJIS[EDITOR_OPT_LEN+1];      /* SJIS̎̃IvV */
    _TCHAR      EditOptUTF16[EDITOR_OPT_LEN+1];     /* UTF16̎̃IvV */
    _TCHAR      EditOptUTF16BE[EDITOR_OPT_LEN+1];   /* UTF16(BE)̎̃IvV */
    _TCHAR      EditOptUTF8[EDITOR_OPT_LEN+1];      /* UTF8̎̃IvV */
    _TCHAR      EditOptUTF7[EDITOR_OPT_LEN+1];      /* UTF7̎̃IvV */
} EXTSET;


/*===== WXgɕۑݒl =====*/
typedef struct {
    EXTSET      *ExtSetTbl;     /* t@C^Cvʐݒe[u */
    int         ExtSetNum;      /* t@C^Cvʐݒ̌ */
    int         ExtSetMax;      /* t@C^Cvʐݒ݂̌̃obt@̍ő */

    ACCEL       *AcceleratorTable;      /* ANZ[^̃e[u */
    int         AcceleratorDataNum;     /* ANZ[^̃f[^ */
    int         AcceleratorDataMax;     /* ANZ[^݂̌̃obt@̍ő */

    int         WinPosX;        /* EChÊwʒu */
    int         WinPosY;        /* EChÊxʒu */
    int         WinWidth;       /* EChẺ */
    int         WinHeight;      /* EChE̍ */
    int         Maximize;       /* ő剻Ă邩ǂ */
    int         SaveWinSize;    /* EChẼTCYۑ邩ǂ */
    int         SaveWinPos;     /* EChËʒuۑ邩ǂ */
    int         ToolBar;        /* c[o[\邩ǂ */
    int         StatusBar;      /* Xe[^Xo[\邩ǂ */
    int         DispCaret;      /* }EXJ[\ʒu𔽓]\邩ǂ */
    int         SmoothLine;     /* 1sX[YɃXN[邩ǂ */
    int         SmoothPage;     /* y[WX[YɃXN[邩ǂ */
    int         SmoothRate;     /* PsX[YXN[̒l */

    int         RegType;        /* WXg̃^Cv */

    _TCHAR      QuoteStr[QUOTE_MAXLEN+1];   /* p */

    int         ErrBell;        /* G[Ƀx炷ǂ */

    int         FileHist;       /* t@C̃qXg */

    FINDDLGDATA FindData;       /*  */
    _TCHAR      FindHist[FINDHIST_NUM*(FINDSTR_LEN+1)+1];   /* ̃qXg */
} GLOBALSET;


/*===== WI{^̐ݒ =====*/
typedef struct {
    int ButID;                  /* {^ID */
    int Value;                  /* l */
} RADIOBUTTON;


/*===== R[hϊpPbg =====*/
typedef struct {
    BYTE    *OrgStr;            /*  */
    int     OrgLen;             /* ̒ */
    BYTE    *Str;               /* ϊ̕i[obt@ */
    int     Len;                /* ϊ̃̕TCY */
} CODECONVINFO;


/*===== c[I҂`FbNpf[^ =====*/
typedef struct editwait_struc {
    HANDLE hProc;                   /* c[̃vZXnh */
    HWND hWnd;                      /* I|̃bZ[W𑗂EChE */
    int EndMesg;                    /* I|̃bZ[W */
    WPARAM wParam;                  /* Iɑ郁bZ[WwParaml */
    LPARAM lParam;                  /* Iɑ郁bZ[WlParaml */
    struct editwait_struc *Next;    /* linked list */
} EDITWAIT;



/*===== vg^Cv =====*/

/* codecnv.c */
void ConvEUCtoSJIS(CODECONVINFO *cInfo);
void ConvJIStoSJIS(CODECONVINFO *cInfo);
int CheckEncoding(BYTE *text, int size, int encode);
int CheckTerminationCode(LPTSTR text, int size);

/* edit.c */
void ExecEditor(FILEMANTBL *tbl, HWND hWndPar, int endMsg, WPARAM wParam, LPARAM lParam);
int AskEditWait(void);
int ExitAllEditor(int sendMsg);

/* fileaccess.c */
void GetLinkTarget(HWND hWnd, LPTSTR filename);
int AddFileData(FILEMANTBL **anchor);
int RemoveFileData(FILEMANTBL **anchor, int num);
FILEMANTBL *AskFileData(FILEMANTBL **anchor, int num);
FILEMANTBL *AskCurFileTbl(void);
void OpenViewFromFile(LPTSTR filename, int topLine, int encoding, int keepSet);
void ReopenViewFromFile(int encoding);
void OpenViewFromClipBoard(int topLine);
void OpenViewFromStdin(int topLine);

/* filetable.c */
int MakeLineTopTbl(FILEMANTBL *tbl);
int GetTabWidth(int tabWidth, int col);
void RemoveLineTopTbl(FILEMANTBL *tbl);
LPTSTR GetLineTop(FILEMANTBL *tbl, int num);
int GetLineLen(FILEMANTBL *tbl, int num);
int GetLogicalLineNum(FILEMANTBL *tbl, int num);
int GetLineNumFromLogicalLineNum(FILEMANTBL *tbl, int num);
int AskWordTopAndBtm(FILEMANTBL *tbl, LPTSTR text, LPTSTR *top, LPTSTR *btm);
int AskPhysLineTopAndBtm(FILEMANTBL *tbl, LPTSTR text, LPTSTR *top, LPTSTR *btm);
int SearchText(FILEMANTBL *tbl, int num, LPTSTR key, int caps, int regexp, int scanDist);
void CancelSearchText(FILEMANTBL *tbl);
int SearchNextFoundLine(FILEMANTBL *tbl, int num);
int SearchPrevFoundLine(FILEMANTBL *tbl, int num);
int AskSearched(FILEMANTBL *tbl);
int AskCurPosFound(FILEMANTBL *tbl, LPTSTR text);
LPTSTR GetNextFoundPos(FILEMANTBL *tbl, LPTSTR text, int *mLen);
LPTSTR GetPrevFoundPos(FILEMANTBL *tbl, LPTSTR text, int *mLen);
void MakeAttributeTable(FILEMANTBL *tbl);
void RemoveAttributeTable(FILEMANTBL *tbl);
int AskCurPosAttr(FILEMANTBL *tbl, LPTSTR text, int *len, int *attr);
LPTSTR GetNextAttrPos(FILEMANTBL *tbl, LPTSTR text, int *len, int *attr);

/* linenumwin.c */
int MakeNumWindow(HWND hWnd);
void DeleteNumWindow(void);
HWND GetNumWinHwnd(void);
void ResizeNumWindow(void);
void ScrollUpDownNum(int num);
void CalcLineNumWinWidth(void);
int AskNumWinWidth(void);

/* main.c */
int PASCAL _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpszCmdLine, int cmdShow);
HINSTANCE GetProgInst(void);
HWND GetMainHwnd(void);
LPTSTR AskHelpFilePath(void);
LPTSTR AskIniFilePath(void);
char *AskIniFilePathAnsi(void);
void SetCurExtNum(void);
EXTSET *AskCurExtSet(void);
int AskCurExtSetNum(void);
void RingErrorBell(void);
void DispErrorBox(LPTSTR szFormat,...);
void LoadDefaultExtSet(EXTSET *tbl);

/* misc.c */
int InputDialogBox(int resourceId, HWND hWnd, LPTSTR title, LPTSTR buf, int bufSize, int *check);
BOOL CALLBACK ExeEscDialogProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK ExeEscMsgDialogProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
void SetYenTail(LPTSTR str);
void RemoveReturnCode(LPTSTR str);
int AskMultiStrLen(LPTSTR mulStr);
int CountMultiStrNum(LPTSTR mulStr);
int InsertStrToMultiStr(LPTSTR str, LPTSTR mulStr, int bufSize);
int DeleteStrFromMultiStr(LPTSTR str, LPTSTR mulStr);
int DeleteNumFromMultiStr(int num, LPTSTR mulStr);
int GetStrLenOfCopyToClipboard(LPTSTR str, int len, LPTSTR quote);
void CopyStrToClipboard(LPTSTR buf, LPTSTR str, int len, LPTSTR quote);
LPTSTR GetFileName(LPTSTR path);
LPTSTR GetFileExt(LPTSTR path);
void RemoveFileName(LPTSTR path, LPTSTR buf);
int SelectFileToOpenEx(HWND hWnd, LPTSTR filename, LPTSTR title, LPTSTR filters, LPTSTR extension, int *encode);
int SelectFileToOpen(HWND hWnd, LPTSTR filename, LPTSTR title, LPTSTR filters, LPTSTR extension);
int SelectFileToSave(HWND hWnd, LPTSTR filename, LPTSTR title, LPTSTR filters, LPTSTR extension);
void SetRadioButtonByValue(HWND hDlg, int value, const RADIOBUTTON *buttons, int num);
int AskRadioButtonValue(HWND hDlg, const RADIOBUTTON *buttons, int num);
void DoPrintf(LPTSTR szFormat, ...);
int MoveFileToTrashCan(LPTSTR path);
void *Malloc(size_t size);
void *Realloc(void *block, size_t size);

/* option.c */
int SetOption(HWND hWnd);
void CopyPresetAppKeyTable(int type);
void RegistAppKeyTable(void);
void UnregistAppKeyTable(void);
void CheckRange2(int *cur, int max, int min);

/* patman.c */
int DispPatSetDlg(HWND hWnd);

/* registory.c */
void SaveRegistory(void);
int LoadRegistory(_TCHAR *history);
void ClearRegistory(void);
void SaveSettingsToFile(void);
int LoadSettingsFromFile(void);

/* statuswin.c */
int MakeStatusWindow(HWND hWnd);
HWND GetStatusWinHwnd(void);
int GetStatusWinHeight(void);
void ResizeStatusWin(void);
void DispEncoding(int encoding);
void DispTerminationCode(int term);
void DispCurrentLineNum(int pos, int num);
void DispFileInfo(LPTSTR Fname);

/* toolmenu.c */
int MakeToolBarWindow(HWND hWnd);
HWND GetToolBarHwnd(void);
HWND GetCurSetWinHwnd(void);
int GetToolBarHeight(void);
void ResizeToolBar(void);
void MakeButtonsHide(void);
void SetEncodingMenu(int encoding);
void SetCurSetWin(void);
void SetCurSetNumToCurSetWin(void);
void SetMenuAndKey(void);
void RightButtonMenu(void);
void AddFileToHistory(LPTSTR filename);
void SetAllHistoryToMenu(LPTSTR buf, int max);
void RemoveAllHistoryFromMenu(void);
void GetAllHistoryFromMenu(LPTSTR buf, int max);
int GetFnameFromHistory(int menuCommand, LPTSTR buf);

/* viewwin.c */
int MakeViewWindow(HWND hWnd);
void DeleteViewWindow(void);
HWND GetViewWinHwnd(void);
void SetViewBackColor(COLORREF color);
HBRUSH AskViewBackColor(void);
void ResizeViewWindow(void);
void SetFontSize(void);
void SetCellSize(void);
int AskCharCellHeight(void);
void SetWindowSize(void);
int AskRegSelected(void);
void SetScrollBar(void);
void SetDispTopWindowMatch(void);
int AskDispFindRev(void);
void DispMousePos(void);

/* wildcard.c */
int CheckFnameWithArray(LPTSTR filename, LPTSTR mulExp);
int CheckFname(LPTSTR filename, LPTSTR exp);

/* updatebell.c */
void SaveUpdateBellInfo(void);

