/*===========================================================================
/
/									ttPage
/							c[o[ƃj[o[
/
/============================================================================
/ Copyright (C) 1998-2007 Sota. All rights reserved.
/
/ Redistribution and use in source and binary forms, with or without 
/ modification, are permitted provided that the following conditions 
/ are met:
/
/  1. Redistributions of source code must retain the above copyright 
/     notice, this list of conditions and the following disclaimer.
/  2. Redistributions in binary form must reproduce the above copyright 
/     notice, this list of conditions and the following disclaimer in the 
/     documentation and/or other materials provided with the distribution.
/
/ THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
/ IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
/ OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
/ IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, 
/ INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
/ BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF 
/ USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON 
/ ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
/ (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF 
/ THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
/============================================================================*/

#define  STRICT
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windowsx.h>
#include <commctrl.h>
#include <tchar.h>

#include "common.h"
#include "resource.h"


/*===== vg^Cv =====*/

static void AddOneFnameToMenu(LPTSTR filename, int num);

/*===== [Jȃ[N =====*/

static HWND hWndTbar = NULL;
static HWND hWndCurSet = NULL;

static HFONT DlgFont = NULL;

static TBBUTTON TbarData[] = {
	{ 0, 0, TBSTATE_ENABLED, TBSTYLE_SEP, 0, 0 },
	{ 0,  MENU_OPEN, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0 },
	{ 1,  MENU_SAVEAS, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0 },
	{ 0, 0, TBSTATE_ENABLED, TBSTYLE_SEP, 0, 0 },
	{ 2,  MENU_COPY, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0 },
	{ 3,  MENU_PASTE, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0 },
	{ 0, 0, TBSTATE_ENABLED, TBSTYLE_SEP, 0, 0 },
	{ 4,  MENU_FIND, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0 },
	{ 5,  MENU_FINDNEXT, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0 },
	{ 6,  MENU_FINDPREV, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0 },
	{ 7,  MENU_FINDDISP, TBSTATE_ENABLED, TBSTYLE_CHECK, 0, 0 },
	{ 0, 0, TBSTATE_ENABLED, TBSTYLE_SEP, 0, 0 },
	{ 8,  MENU_EDITOR, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0 },
	{ 0, 0, TBSTATE_ENABLED, TBSTYLE_SEP, 0, 0 }
};

static HMENU mainMenu = NULL;

static int MenuHistId[HISTORY_MAX] = {
	MENU_HIST_1,  MENU_HIST_2,  MENU_HIST_3,  MENU_HIST_4,  MENU_HIST_5,
	MENU_HIST_6,  MENU_HIST_7,  MENU_HIST_8,  MENU_HIST_9,  MENU_HIST_10,
	MENU_HIST_11, MENU_HIST_12, MENU_HIST_13, MENU_HIST_14, MENU_HIST_15,
	MENU_HIST_16, MENU_HIST_17, MENU_HIST_18, MENU_HIST_19, MENU_HIST_20
};

/*===== OQ =====*/

GLOBALSET	GlobalSet;			/* ݒl */


/*-------------------------------------------------------------------------------
Name    :	MakeToolBarWindow
Desc    :	c[o[쐬
Param   :	hWnd		eEChẼEChEnh
Return  :	Xe[^X (SUCCESS/FAIL)
Note    :	
-------------------------------------------------------------------------------*/
int MakeToolBarWindow(HWND hWnd)
{
	int		sts;
	RECT	rect;

	sts = FAIL;
	hWndTbar = CreateToolbarEx(
				hWnd,
				WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | TBSTYLE_TOOLTIPS | CCS_TOP,
				1,
				24,
				GetProgInst(),
				toolbar_bmp,
				TbarData,
				sizeof(TbarData)/sizeof(TBBUTTON),
				16,16,
				16,16,
				sizeof(TBBUTTON));

	if(hWndTbar != NULL)
	{
		MoveWindow(hWndTbar, 0, 0, GlobalSet.WinWidth, TOOLWIN_HEIGHT, FALSE);
		ShowWindow(hWndTbar, SW_SHOW);

		/* ݒ薼EChE쐬 */
		SendMessage(hWndTbar, TB_GETITEMRECT, 13, (LPARAM)&rect);
		hWndCurSet = CreateWindowEx(WS_EX_CLIENTEDGE,
					_T("COMBOBOX"), _T(""),
					WS_CHILD | WS_VISIBLE | WS_BORDER | CBS_DROPDOWNLIST,
					rect.right, rect.top, 180, 180,
					hWndTbar, (HMENU)WIN_SETNAME, GetProgInst(), NULL);
		if(hWndCurSet)
		{
			DlgFont = CreateFont(rect.bottom-rect.top-8, 0, 0, 0, 0, 
						FALSE, FALSE, FALSE, SHIFTJIS_CHARSET, 
						OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, 
						DEFAULT_QUALITY, DEFAULT_PITCH, MSGJPN_36);
			SendMessage(hWndCurSet, WM_SETFONT, (WPARAM)DlgFont, MAKELPARAM(TRUE, 0));
			SetCurSetWin();
			SetCurSetNumToCurSetWin();
			sts = SUCCESS;
		}
	}
	return(sts);
}


/*-------------------------------------------------------------------------------
Name    :	GetToolBarHwnd
Desc    :	c[o[̃EChEnhԂ
Param   :	none
Return  :	EChEnh
Note    :	
-------------------------------------------------------------------------------*/
HWND GetToolBarHwnd(void)
{
	return(hWndTbar);
}


/*-------------------------------------------------------------------------------
Name    :	GetCurSetWinHwndGetCurSetWinHwndGetCurSetWinHwnd
Desc    :	ݒ薼EChỄEChEnhԂ
Param   :	none
Return  :	EChEnh
Note    :	
-------------------------------------------------------------------------------*/
HWND GetCurSetWinHwnd(void)
{
	return(hWndCurSet);
}


/*-------------------------------------------------------------------------------
Name    :	GetToolBarHeight
Desc    :	c[o[̍Ԃ
Param   :	none
Return  :	
Note    :	
-------------------------------------------------------------------------------*/
int GetToolBarHeight(void)
{
	int		ret;

	ret = 0;
	if(hWndTbar != NULL)
	{
		ret = TOOLWIN_HEIGHT;
	}
	return(ret);
}


/*-------------------------------------------------------------------------------
Name    :	ResizeToolBar
Desc    :	c[o[TCYύX̏
Param   :	none
Return  :	none
Note    :	CEChEc[o[^Xe[^Xo[r[EChȄ
			TCYύX邱
-------------------------------------------------------------------------------*/
void ResizeToolBar(void)
{
	RECT	rect;

	if(hWndTbar != NULL)
	{
		GetClientRect(GetMainHwnd(), &rect);
		SetWindowPos(hWndTbar, NULL, 0, 0, rect.right, GetToolBarHeight(), SWP_NOACTIVATE | SWP_NOZORDER | SWP_NOMOVE);
	}
	return;
}


/*-------------------------------------------------------------------------------
Name    :	MakeButtonsHide
Desc    :	c[{^^j[̃nCh
Param   :	none
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
void MakeButtonsHide(void)
{
	static const UINT	menu[2] = { MF_ENABLED, MF_GRAYED };
	static const UINT	menuCheck[2] = { MF_CHECKED, MF_UNCHECKED };
	static const int	button[2] = { TRUE, FALSE };
	HMENU				mainMenu;
	int					sts;

	mainMenu = GetMenu(GetMainHwnd());

	sts = 0;
	if(AskCurFileTbl() == NULL)
	{
		sts = 1;
	}
	EnableMenuItem(mainMenu, MENU_FILETOP, menu[sts]);
	EnableMenuItem(mainMenu, MENU_FILEBTM, menu[sts]);
	EnableMenuItem(mainMenu, MENU_SELALL, menu[sts]);
	EnableMenuItem(mainMenu, MENU_GOTO, menu[sts]);
	EnableMenuItem(mainMenu, MENU_FIND, menu[sts]);
	EnableMenuItem(mainMenu, MENU_SAVEAS, menu[sts]);
	EnableMenuItem(mainMenu, MENU_LINENUM, menu[sts]);
	SendMessage(hWndTbar, TB_ENABLEBUTTON, MENU_FIND, MAKELONG(button[sts], 0));
	SendMessage(hWndTbar, TB_ENABLEBUTTON, MENU_SAVEAS, MAKELONG(button[sts], 0));

	sts = 0;
	if((AskCurFileTbl() == NULL) || (AskCurFileTbl()->ReadFrom != READFROM_FILE))
	{
		sts = 1;
	}
	EnableMenuItem(mainMenu, MENU_SJIS, menu[sts]);
	EnableMenuItem(mainMenu, MENU_JIS, menu[sts]);
	EnableMenuItem(mainMenu, MENU_EUC, menu[sts]);
	EnableMenuItem(mainMenu, MENU_UTF16, menu[sts]);
	EnableMenuItem(mainMenu, MENU_UTF16_BE, menu[sts]);
	EnableMenuItem(mainMenu, MENU_UTF8, menu[sts]);
	EnableMenuItem(mainMenu, MENU_UTF7, menu[sts]);
	EnableMenuItem(mainMenu, MENU_EDITOR, menu[sts]);
	SendMessage(hWndTbar, TB_ENABLEBUTTON, MENU_EDITOR, MAKELONG(button[sts], 0));

	sts = 0;
	if((AskCurFileTbl() == NULL) || (AskSearched(AskCurFileTbl()) == NO))
	{
		sts = 1;
	}
	EnableMenuItem(mainMenu, MENU_FINDNEXT, menu[sts]);
	EnableMenuItem(mainMenu, MENU_FINDPREV, menu[sts]);
	SendMessage(hWndTbar, TB_ENABLEBUTTON, MENU_FINDNEXT, MAKELONG(button[sts], 0));
	SendMessage(hWndTbar, TB_ENABLEBUTTON, MENU_FINDPREV, MAKELONG(button[sts], 0));

	sts = 0;
	if(AskDispFindRev() == NO)
	{
		sts = 1;
	}
	SendMessage(hWndTbar, TB_CHECKBUTTON, MENU_FINDDISP, MAKELONG(button[sts], 0));
	CheckMenuItem(mainMenu, MENU_FINDDISP, menuCheck[sts]);

	sts = 0;
	if((AskCurFileTbl() == NULL) || (AskSearched(AskCurFileTbl()) == NO))
	{
		sts = 1;
	}
	EnableMenuItem(mainMenu, MENU_FINDDISP, menu[sts]);
	SendMessage(hWndTbar, TB_ENABLEBUTTON, MENU_FINDDISP, MAKELONG(button[sts], 0));

	sts = 0;
	if((AskCurFileTbl() == NULL) || (AskRegSelected() == NO))
	{
		sts = 1;
	}
	EnableMenuItem(mainMenu, MENU_COPY, menu[sts]);
	EnableMenuItem(mainMenu, MENU_APPENDCOPY, menu[sts]);
	EnableMenuItem(mainMenu, MENU_QUOTECOPY, menu[sts]);
	SendMessage(hWndTbar, TB_ENABLEBUTTON, MENU_COPY, MAKELONG(button[sts], 0));

	return;
}


/*-------------------------------------------------------------------------------
Name    :	SetEncodingMenu
Desc    :	R[h̎ނɂă`FbN}[N\
Param   :	encoding	GR[fBO (ENCODE_xxx)
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
void SetEncodingMenu(int encoding)
{
	HMENU	hMenu;

	hMenu = GetMenu(GetMainHwnd());

	CheckMenuItem(hMenu, MENU_SJIS, MF_UNCHECKED);
	CheckMenuItem(hMenu, MENU_JIS, MF_UNCHECKED);
	CheckMenuItem(hMenu, MENU_EUC, MF_UNCHECKED);
	CheckMenuItem(hMenu, MENU_UTF16, MF_UNCHECKED);
	CheckMenuItem(hMenu, MENU_UTF16_BE, MF_UNCHECKED);
	CheckMenuItem(hMenu, MENU_UTF8, MF_UNCHECKED);
	CheckMenuItem(hMenu, MENU_UTF7, MF_UNCHECKED);

	switch(encoding)
	{
		case ENCODE_SJIS :
			CheckMenuItem(hMenu, MENU_SJIS, MF_CHECKED);
			break;

		case ENCODE_JIS :
			CheckMenuItem(hMenu, MENU_JIS, MF_CHECKED);
			break;

		case ENCODE_EUC :
			CheckMenuItem(hMenu, MENU_EUC, MF_CHECKED);
			break;

		case ENCODE_UTF16_BOM :
		case ENCODE_UTF16_NOBOM :
			CheckMenuItem(hMenu, MENU_UTF16, MF_CHECKED);
			break;

		case ENCODE_UTF16_BOM_BE :
		case ENCODE_UTF16_NOBOM_BE :
			CheckMenuItem(hMenu, MENU_UTF16_BE, MF_CHECKED);
			break;

		case ENCODE_UTF8_BOM :
		case ENCODE_UTF8_NOBOM :
			CheckMenuItem(hMenu, MENU_UTF8, MF_CHECKED);
			break;

		case ENCODE_UTF7_NOBOM :
			CheckMenuItem(hMenu, MENU_UTF7, MF_CHECKED);
			break;

		default :
			break;
	}
	return;

}


/*-------------------------------------------------------------------------------
Name    :	SetCurSetWin
Desc    :	ݒ薼EChEɐݒ薼Zbg
Param   :	none
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
void SetCurSetWin(void)
{
	int		i;

	SendMessage(hWndCurSet, CB_RESETCONTENT, 0, 0);
	for(i = 0; i < GlobalSet.ExtSetNum; i++)
	{
		SendMessage(hWndCurSet, CB_ADDSTRING, 0, (LPARAM)GlobalSet.ExtSetTbl[i].Name);
	}
	return;
}


/*-------------------------------------------------------------------------------
Name    :	SetCurSetNumToCurSetWin
Desc    :	ݒ薼EChEɌ݂̐ݒԍZbg
Param   :	none
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
void SetCurSetNumToCurSetWin(void)
{
	SendMessage(GetCurSetWinHwnd(), CB_SETCURSEL, AskCurExtSetNum(), 0);
	return;
}


/*-------------------------------------------------------------------------------
Name    :	SetMenuAndKey
Desc    :	L[@ɏ]ăj[ƃANZ[^ݒ肷
Param   :	none
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
void SetMenuAndKey(void)
{
	LPTSTR	buf;

	if((buf = Malloc(((MAX_PATH + 1) * sizeof(_TCHAR)) * HISTORY_MAX + 1)) != NULL)
	{
		GetAllHistoryFromMenu(buf, HISTORY_MAX);
	}
	if(buf != NULL)
	{
		SetAllHistoryToMenu(buf, GlobalSet.FileHist);
		free(buf);
	}

	MakeButtonsHide();

	RegistAppKeyTable();

	return;
}


/*-------------------------------------------------------------------------------
Name    :	RightButtonMenu
Desc    :	E{^j[\
Param   :	none
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
void RightButtonMenu(void)
{
	HMENU	hMenu;
	POINT	point;
	UINT	flag1;
	UINT	flag2;

	flag1 = MF_GRAYED;
	flag2 = MF_GRAYED;
	if(AskCurFileTbl() != NULL)
	{
		if(AskRegSelected() == YES)
		{
			flag1 = 0;
		}
		if(AskCurFileTbl()->ReadFrom == READFROM_FILE)
		{
			flag2 = 0;
		}
	}

	hMenu = CreatePopupMenu();
	AppendMenu(hMenu, MF_STRING | flag1, MENU_COPY, MSGJPN_37);
	AppendMenu(hMenu, MF_STRING | flag1, MENU_APPENDCOPY, MSGJPN_38);
	AppendMenu(hMenu, MF_STRING | flag1, MENU_QUOTECOPY, MSGJPN_39);
	AppendMenu(hMenu, MF_SEPARATOR, 0, NULL);
	AppendMenu(hMenu, MF_STRING | flag2, MENU_EDITOR, MSGJPN_40);

	GetCursorPos(&point);
	TrackPopupMenu(hMenu, TPM_LEFTBUTTON | TPM_RIGHTBUTTON, point.x, point.y, 0, GetMainHwnd(), NULL);
	DestroyMenu(hMenu);

	return;
}


/*-------------------------------------------------------------------------------
Name    :	AddFileToHistory
Desc    :	t@CqXg̐擪ɒǉ
Param   :	filename	t@C
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
void AddFileToHistory(LPTSTR filename)
{
	LPTSTR	buf;
	LPTSTR	pos;
	int		i;

	if(GlobalSet.FileHist > 0)
	{
		if((buf = Malloc(((MAX_PATH + 1) *sizeof(_TCHAR)) * HISTORY_MAX + 1)) != NULL)
		{
			GetAllHistoryFromMenu(buf, GlobalSet.FileHist);
			RemoveAllHistoryFromMenu();

			AddOneFnameToMenu(filename, 0);
			pos = buf;
			i = 1;
			while(*pos != NUL)
			{
				if(i >= GlobalSet.FileHist)
				{
					break;
				}
				if(_tcsicmp(filename, pos) != 0)
				{
					AddOneFnameToMenu(pos, i);
					i++;
				}
				pos = _tcschr(pos, NUL) + 1;
			}
			free(buf);
		}
	}
	return;
}


/*-------------------------------------------------------------------------------
Name    :	SetAllHistoryToMenu
Desc    :	}`qXgɃZbg
Param   :	buf		pXi}`j
			max		ő
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
void SetAllHistoryToMenu(LPTSTR buf, int max)
{
	int		i;

	RemoveAllHistoryFromMenu();
	i = 0;
	while(*buf != NUL)
	{
		if(i >= max)
		{
			break;
		}
		AddOneFnameToMenu(buf, i);
		buf = _tcschr(buf, NUL) + 1;
		i++;
	}
	return;
}


/*-------------------------------------------------------------------------------
Name    :	AddOneFnameToMenu
Desc    :	qXgɃt@Cǉ
Param   :	filename	t@C
			num			ԍ
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
static void AddOneFnameToMenu(LPTSTR filename, int num)
{
	HMENU	hMenu;
	_TCHAR	tmp[MAX_PATH+4];

	hMenu = GetSubMenu(GetMenu(GetMainHwnd()), 0);

	if(num == 0)
	{
		AppendMenu(hMenu, MF_SEPARATOR, 0, NULL);
	}

	if(num < 9)
	{
		_stprintf(tmp, _T("&%d "), num+1);
	}
	else if(num == 9)
	{
		_tcscpy(tmp, _T("&0 "));
	}
	else
	{
		_tcscpy(tmp, _T("&* "));
	}

	_tcscat(tmp, filename);
	AppendMenu(hMenu, MF_STRING, MenuHistId[num], tmp);

	return;
}


/*-------------------------------------------------------------------------------
Name    :	RemoveAllHistoryFromMenu
Desc    :	SqXg폜
Param   :	none
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
void RemoveAllHistoryFromMenu(void)
{
	HMENU	hMenu;
	int		cnt;
	int		i;

	hMenu = GetSubMenu(GetMenu(GetMainHwnd()), 0);
	cnt = GetMenuItemCount(hMenu);
	for(i = DEF_FMENU_ITEMS; i < cnt; i++)
	{
		DeleteMenu(hMenu, DEF_FMENU_ITEMS, MF_BYPOSITION);
	}
	return;
}


/*-------------------------------------------------------------------------------
Name    :	GetAllHistoryFromMenu
Desc    :	qXg}`쐬
Param   :	buf		Rs[obt@
			max		ő
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
void GetAllHistoryFromMenu(LPTSTR buf, int max)
{
	HMENU	hMenu;
	int		cnt;
	int		i;
	_TCHAR	tmp[MAX_PATH+4];

	*buf = NUL;
	if(max > 0)
	{
		hMenu = GetSubMenu(GetMenu(GetMainHwnd()), 0);
		cnt = GetMenuItemCount(hMenu);
		for(i = DEF_FMENU_ITEMS+1; i < cnt; i++)
		{
			GetMenuString(hMenu, i, tmp, MAX_PATH, MF_BYPOSITION);
			_tcscpy(buf, tmp+3);
			buf = _tcschr(buf, NUL) + 1;
			*buf = NUL;
		}
	}
	return;
}


/*-------------------------------------------------------------------------------
Name    :	GetFnameFromHistory
Desc    :	wԍ̃qXgԂ
Param   :	menuCommand		oqXgɊ蓖Ăꂽj[R}h
			buf				[out] 
Return  :	Xe[^X (SUCCESS/FAIL)
Note    :	
-------------------------------------------------------------------------------*/
int GetFnameFromHistory(int menuCommand, LPTSTR buf)
{
	HMENU	hMenu;
	int		sts;
	_TCHAR	tmp[MAX_PATH+4];

	*buf = NUL;
	sts = FAIL;
	hMenu = GetSubMenu(GetMenu(GetMainHwnd()), 0);
	if(GetMenuString(hMenu, menuCommand, tmp, MAX_PATH+9, MF_BYCOMMAND) > 0)
	{
		_tcscpy(buf, tmp+3);
		sts = SUCCESS;
	}
	return(sts);
}


